<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div
    data-backdrop="static"
    data-keyboard="false"
    class="modal s--modal s--modal-right animated fadeInRight"
    id="edit_attribute_custom"
  >
    <div class="modal-dialog" style="max-width: 450px;">
      <div class="modal-content">
        <div class="modal-header">
          <h3 class="modal-title">Chỉnh sửa trường dữ liệu</h3>
          <button
            type="button"
            class="close"
            data-dismiss="modal"
            aria-label="Close"
            @click.prevent="reset()"
          >
            <span aria-hidden="true">
              <i class="la la-times"></i>
            </span>
          </button>
        </div>
        <div class="modal-body" data-scrollable="true" data-scrollbar-shown="true">
          <div class="row m-form">
            <div class="col-md-12">
              <div
                class="s--alert m-alert m-alert--outline alert alert-success text-center"
                v-if="isSuccess"
              >
                <div class="s--alert-icon">
                  <i class="la la-check"></i>
                </div>
                <div class="s--alert-message">
                  <h5 class="s--alert-heading">Cập nhật trường dữ liệu thành công.</h5>
                </div>
              </div>
            </div>

            <div class="col-md-12">
              <div
                class="form-group m-form__group"
                :class="{ 'has-danger': errors.has('updateAttribute.attribute_name') || server_errors != '' && server_errors['attribute_name']}"
              >
                <label for="attribute_name" class="form-control-label nt-label">
                  Tên trường dữ liệu
                  <span class="m--font-danger">*</span>
                </label>

                <s-input-text
                  data-vv-scope="updateAttribute"
                  v-validate="{ required: true, max: 250 }"
                  v-on:keyup="getAttributeCode(attribute.attribute_name)"
                  v-on:blur="getAttributeCode(attribute.attribute_name)"
                  :id="'attribute_name'"
                  class="form-control"
                  :name="'attribute_name'"
                  v-model="attribute.attribute_name"
                ></s-input-text>

                <div
                  class="form-control-feedback m--font-danger"
                  v-if="errors.has('updateAttribute.attribute_name')"
                >{{ errors.first('updateAttribute.attribute_name') }}</div>
                <div class="form-control-feedback m--font-danger" v-else>
                  <div
                    class="form-control-feedback m--font-danger"
                    v-if="server_errors != '' && server_errors['attribute_name']"
                  >
                    <template
                      v-if="server_errors['attribute_name'].exist"
                    >Tên trường dữ liệu bị trùng.</template>
                    <template v-else>{{ server_errors['attribute_name'][0] }}</template>
                  </div>
                  <div v-else>&nbsp;</div>
                </div>
              </div>

              <div class="form-group m-form__group">
                <label class="form-control-label nt-label">Tên trường khi chọn gán biến</label>

                <s-input-text
                  data-vv-scope="updateAttribute"
                  disabled
                  v-model="attribute.attribute_code"
                  class="form-control"
                ></s-input-text>

                <div class="m-form__help">Dùng để chọn biến gán khi tạo email template, SMS template</div>
                <div class="form-control-feedback m--font-danger">&nbsp;</div>
              </div>

              <div
                class="form-group m-form__group"
                :class="{ 'has-danger': errors.has('updateAttribute.data_type_id') }"
              >
                <label for="data_type_id" class="form-control-label nt-label">
                  Kiểu điền dữ liệu
                  <span class="m--font-danger">*</span>
                </label>

                <s-select
                  disabled
                  data-vv-scope="updateAttribute"
                  v-model.number="attribute.data_type_id"
                  name="data_type_id"
                  class="form-control"
                  id="data_type_id"
                  v-validate="{ required: true }"
                  :data="attributeDataType"
                  :label="'data_type_name'"
                ></s-select>

                <div
                  class="form-control-feedback m--font-danger"
                  v-if="errors.has('updateAttribute.data_type_id')"
                >{{ errors.first('updateAttribute.data_type_id') }}</div>
                <div class="form-control-feedback m--font-danger" v-else>
                  <div
                    class="form-control-feedback m--font-danger"
                    v-if="server_errors != '' && server_errors['data_type_id']"
                  >{{ server_errors['data_type_id'][0] }}</div>
                  <div v-else>&nbsp;</div>
                </div>
              </div>
              <div
                v-if="attribute.data_type_id == isSelect || attribute.data_type_id == isSelectFind || attribute.data_type_id == isRadio || attribute.data_type_id == isMultipleSelect || attribute.data_type_id == isCheckboxMultiple || attribute.data_type_id == isTag || attribute.data_type_id == isStatusBar"
                :class="{ 'has-danger': errors.has('updateAttribute.attribute_options') || listExistsAttributeOptions.length > 0 }"
                class="form-group m-form__group"
                style="position: relative;"
              >
                <label for="attribute_options" class="form-control-label nt-label">
                  Các giá trị lựa chọn
                  <span class="m--font-danger">*</span>
                </label>

                <template v-if="isLoader">
                  <s-textarea rows="6" class="form-control s--select-multile-value"></s-textarea>
                  <div
                    class="m-loader m-loader--brand m-loader--lg"
                    style="width: 30px; height: 30px; display: inline-block; top: 40px; left: 10px; position: absolute;"
                  ></div>
                </template>
                <template v-else>
                  <s-textarea
                    data-vv-scope="updateAttribute"
                    v-model="attribute.attribute_options"
                    name="attribute_options"
                    v-validate="{ required: true }"
                    id="attribute_options"
                    rows="6"
                    class="form-control s--select-multile-value"
                    @keyup="changeAttributeOptions(attribute.attribute_options)"
                  ></s-textarea>
                </template>

                <div
                  class="form-control-feedback m--font-danger"
                  v-if="errors.has('updateAttribute.attribute_options')"
                >{{ errors.first('updateAttribute.attribute_options') }}</div>
                <div class="form-control-feedback m--font-danger" v-else>
                  <template
                    v-if="server_errors != '' && server_errors['attribute_options']"
                  >Giá trị lựa chọn bị trùng.</template>
                  <template
                    v-else-if="listExistsAttributeOptions.length > 0"
                  >Giá trị lựa chọn bị trùng.</template>
                  <template v-else>&nbsp;</template>
                </div>
              </div>
              <div
                class="form-group m-form__group"
                :class="{ 'has-danger': errors.has('updateAttribute.show_position') }"
                v-if="attribute.attribute_code != 'level'"
              >
                <label for="attribute_options" class="form-control-label nt-label">
                  Hiển thị trong màn hình Xem chi tiết khách hàng ở tab:
                  <span class="m--font-danger">*</span>
                </label>
                <div class="row">
                  <div class="col-md-12">
                    <div class="m-radio-list">
                      <label class="m-radio m-radio--primary nt-radio nt-radio-primary">
                        <input
                          type="radio"
                          v-model="attribute.show_position"
                          data-vv-scope="updateAttribute"
                          name="show_position"
                          :value="CUSTOMER_DETAIL_BOX_GENERAL"
                          v-validate="{ required: true }"
                        /> Thông tin chung
                        <span></span>
                      </label>
                      <label class="m-radio m-radio--primary nt-radio nt-radio-primary">
                        <input
                          type="radio"
                          v-model="attribute.show_position"
                          data-vv-scope="updateAttribute"
                          name="show_position"
                          :value="CUSTOMER_DETAIL_BOX_BUY"
                          v-validate="{ required: true }"
                        /> Thông tin dành cho người mua hàng
                        <span></span>
                      </label>
                      <label class="m-radio m-radio--primary nt-radio nt-radio-primary">
                        <input
                          type="radio"
                          v-model="attribute.show_position"
                          data-vv-scope="updateAttribute"
                          name="show_position"
                          :value="CUSTOMER_DETAIL_BOX_USE"
                          v-validate="{ required: true }"
                        /> Thông tin dành cho người sử dụng cuối
                        <span></span>
                      </label>
                    </div>
                  </div>
                  <div class="col-md-12">
                    <div
                      class="form-control-feedback m--font-danger"
                      v-if="errors.has('updateAttribute.show_position')"
                    >{{ errors.first('updateAttribute.show_position') }}</div>
                    <div class="form-control-feedback m--font-danger" v-else>&nbsp;</div>
                  </div>
                </div>
              </div>

              <div class="form-group m-form__group">
                <label for="attribute_options" class="form-control-label nt-label">Thuộc tính khác:</label>
                <div class="row">
                  <div class="col-md-12">
                    <label
                      class="nt-checkbox nt-checkbox-primary"
                      v-if="attribute.data_type_id != isRadio"
                    >
                      <input
                        name="is_required"
                        data-vv-scope="updateAttribute"
                        type="checkbox"
                        v-model="attribute.is_required"
                      /> Trường bắt buộc điền
                      <span class="nt-checkbox-symbol"></span>
                    </label>
                    <label class="nt-checkbox nt-checkbox-primary s--disabled-checkbox" v-else>
                      <input
                        name="is_required"
                        data-vv-scope="updateAttribute"
                        type="checkbox"
                        v-model="attribute.is_required"
                      /> Trường bắt buộc điền
                      <span class="nt-checkbox-symbol"></span>
                    </label>
                  </div>
                  <div class="col-md-12">
                    <label
                      class="nt-checkbox nt-checkbox-primary"
                      :class="{ 's--disabled-checkbox': !isDisabledUnique }"
                    >
                      <input
                        name="is_unique"
                        data-vv-scope="updateAttribute"
                        type="checkbox"
                        v-model="attribute.is_unique"
                        :disabled="!isDisabledUnique"
                      /> Trường không cho trùng dữ liệu
                      <span class="nt-checkbox-symbol"></span>
                    </label>
                  </div>
                </div>
              </div>

              <!--<div class="examples-ele" v-if="attribute.data_type_id == isSelect || attribute.data_type_id == isSelectFind || attribute.data_type_id == isRadio || attribute.data_type_id == isMultipleSelect || attribute.data_type_id == isCheckboxMultiple || attribute.data_type_id == isTag || attribute.data_type_id == isStatusBar">
                                <label class="form-control-label">* Mỗi dòng một lựa chọn</label>
                                <div class="form-control-label">
                                    <span>Ví dụ: </span><br>
                                    <span>Lựa chọn 1</span><br>
                                    <span>Lựa chọn 2</span><br>
                                </div>
              </div>-->
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <button
            type="button"
            class="nt-button nt-button-secondary mr-2"
            data-dismiss="modal"
            @click.prevent="reset()"
          >Hủy bỏ</button>
          <button
            :disabled="errors.any() || isLoader || !isChange || listExistsAttributeOptions.length > 0"
            :class="{'nt-button-disabled' : errors.any() || isLoader || !isChange || listExistsAttributeOptions.length > 0}"
            type="submit"
            class="nt-button nt-button-warning mr-0"
            @click.prevent="update('updateAttribute')"
          >Cập nhật</button>
        </div>
      </div>
    </div>
  </div>
</template>
